# Contributing to BGEz

## Git worflow

### Cloning the project locally

```sh
git clone https://gitlab.com/bgez/bgez.git
cd bgez
```

### Merge Request

This is the only way to contribute to the project.

### Forking

GitLab provides a `fork` button on the project's page https://gitlab.com/bgez/bgez.git.

This will create a copy of the repository on your personal account.

You should clone your fork and not the main repository, it is just a simplier workflow.

In the case you don't have write access to the main repository, you can still make contributions to this fork of yours, and then submit a `Merge Request`.

Once this is done, because the fork is the same project as the original one, in your local clone of BGEz you should be able to have the two sources setup at the same time on your repository.

To list the remotes for your local git repository:

```sh
git remote -v

> origin  https://git-thing.com/your/fork.git (fetch)
> origin  https://git-thing.com/your/fork.git (push)
```

If you just cloned the repository, only `origin` should be displayed. It is the default remote target. If you correctly cloned your fork, you are now missing the original remote target. You can add it doing the following:

```sh
git remote add upstream https://gitlab.com/bgez/bgez.git
```

The new `upstream` remote will point to the main repository, this way you will be able to synchronize your fork with the changes made in BGEz.

If you want to discard your changes and reset your state to the default branch:

```sh
git fetch upstream
git reset upstream/two/develop --hard
```

## Contribution Workflow

The best pratice is to always sync with the current develop branch (`two/develop`) and create a new branch from there.

```sh
git checkout two/develop
git branch your/feature
git checkout your/feature
```

If you have any doubt, you can abuse the `git status` command in order to check if you are in the right branch.

Once on your own branch, feel free to make as many commits as you want.

You can push your changes to your fork when you feel like uploading it. You can amend as many things as your want. You can force push on your branch.

Once you feel satisfied, you will be able to create a `Merge Request` on https://gitlab.com/bgez/bgez.git.

## Other issues

If you have trouble using git, simply use Google. You are not the first one to have an issue :)
