from typing import Any, Callable, Coroutine

import inspect

__all__ = [
    'iscoroutine',
    'iscoroutinecreated',
]

def iscoroutine(object):
    return inspect.isgenerator(object) \
        or inspect.iscoroutine(object)

def iscoroutinecreated(object):
    if inspect.isgenerator(object):
        return inspect.getgeneratorstate(object) is inspect.GEN_CREATED
    elif inspect.iscoroutine(object):
        return inspect.getcoroutinestate(object) is inspect.CORO_CREATED
    return False
